# trend2d

Fit [weighted] [robust] polynomial for z = f(x,y) to xyz[w] data

## Synopsis

gmt trend2d [ table ] -F xyzmrw|p -N n_model[+r] [ -C condition_number ] [ -I[confidence_level] ] [ -V[level] ] [ -W[+s|w] ] [ -b binary ] [ -d nodata[+c col] ] [ -e regexp ] [ -f flags ] [ -h headers ] [ -i flags ] [ -q flags ] [ -s flags ] [ -w flags ] [ -:[i|o] ] [ --PAR=value ]

Note: No space is allowed between the option flag and the associated arguments.

## Description

trend2d reads x, y, z [and w] values from the first three [four] columns on standard input [or xyz[w]file] and fits a regression model z = f(x,y) + e by [weighted] least squares [Menke, 1989]. The fit may be made robust by iterative reweighting of the data. The user may also search for the number of terms in f(x,y) which significantly reduce the variance in z. n_model may be in [1,10] to fit a model of the following form (similar to grdtrend):

\[z(x,y) = m_1 + m_{2}x + m_{3}y + m_{4}xy + m_{5}x^2 + m_{6}y^2 + m_{7}x^3 + m_{8}x^{2}y + m_{9}xy^2 + m_{10}y^3.\]

The user must specify -N n_model, the number of model parameters to use; thus, -N4 fits a bilinear trend, -N6 a quadratic surface, and so on. Optionally, append +r to perform a robust fit. In this case, the program will iteratively reweight the data based on a robust scale estimate, in order to converge to a solution insensitive to outliers. This may be handy when separating a “regional” field from a “residual” which should have non-zero mean, such as a local mountain on a regional surface.

## Required Arguments

table

  One or more ASCII [or binary, see -bi] files containing x, y, z[, w] values in the first 3 [4] columns. If no files are specified, trend2d will read from standard input.

-F xyzmrw|p

  Specify up to six letters from the set {x y z m r w} in any order to create columns of ASCII [or binary] output. x = x, y = y, z = z, m = model f(x,y), r = residual z - m, w = weight used in fitting. Alternatively, to just report the model parameters, specify -Fp.

-N n_model[+r]

  Specify the number of terms in the model, n_model, and append +r to do a robust fit. E.g., a robust bilinear model is -N 4+r.

## Optional Arguments

-C condition_number

  Set the maximum allowed condition number for the matrix solution. trend2d fits a damped least squares model, retaining only that part of the eigenvalue spectrum such that the ratio of the largest eigenvalue to the smallest eigenvalue is condition_number. [Default: condition_number = 1.0e06. ].

-I[confidence_level]

  Iteratively increase the number of model parameters, starting at one, until n_model is reached or the reduction in variance of the model is not significant at the confidence_level level. You may set -I only, without an attached number; in this case the fit will be iterative with a default confidence level of 0.51. Or choose your own level between 0 and 1. See remarks section.

-V[level]

  Select verbosity level [w]. (See full description) (See cookbook information).

-W[+s|w]

  Weights are supplied in input column 4. Do a weighted least squares fit [or start with these weights when doing the iterative robust fit]. Append +s to instead read data uncertainties (one sigma) and create weights as 1/sigma2, or use the weights as read (+w) [Default reads only the first 2 columns].

-bi record[+b|l] (more …)

  Select native binary format for primary table input. [Default is 3 (or 4 if -W is set) input columns].

-bo record[+b|l] (more …)

  Select native binary format for table output. [Default is 1-6 columns as set by -F].

-d[i|o][+c col]nodata (more …)

  Replace input columns that equal nodata with NaN and do the reverse on output.

-e[~]“pattern” | -e[~]/regexp/[i] (more …)

  Only accept data records that match the given pattern.

-f[i|o]colinfo (more …)

  Specify data types of input and/or output columns.

-h[i|o][n][+c][+d][+m segheader][+r remark][+t title] (more …)

  Skip or produce header record(s).

-i cols[+l][+d divisor][+s scale|d|k][+o offset][,…][,t[word]] (more …)

  Select input columns and transformations (0 is first column, t is trailing text, append word to read one word only).

-q[i|o][~]rows|limits[+c col][+a|t|s] (more …)

  Select input or output rows or data limit(s) [all].

-s[cols][+a][+r] (more …)

  Set handling of NaN records for output.

-wy|a|w|d|h|m|s|c period[/phase][+c col] (more …)

  Convert an input coordinate to a cyclical coordinate.

-:[i|o] (more …)

  Swap 1st and 2nd column on input and/or output.

-^ or just -

  Print a short message about the syntax of the command, then exit (Note: on Windows just use -).

-+ or just +

  Print an extensive usage (help) message, including the explanation of any module-specific option (but not the GMT common options), then exit.

-? or no arguments

  Print a complete usage (help) message, including the explanation of all options, then exit.

--PAR=value

  Temporarily override a GMT default setting; repeatable. See gmt.conf for parameters.

## Remarks

The domain of x and y will be shifted and scaled to [-1, 1] and the basis functions are built from Chebyshev polynomials. These have a numerical advantage in the form of the matrix which must be inverted and allow more accurate solutions. In many applications of trend2d the user has data located approximately along a line in the x-y plane which makes an angle with the x-axis (such as data collected along a road or ship track). In this case the accuracy could be improved by a rotation of the x-y axes. trend2d does not search for such a rotation; instead, it may find that the matrix problem has deficient rank. However, the solution is computed using the generalized inverse and should still work out OK. The user should check the results graphically if trend2d shows deficient rank. Note: The model parameters listed with -V are Chebyshev coefficients; they are not numerically equivalent to the m coefficients in the equation described above. The description above is to allow the user to match -N with the order of the polynomial surface. For evaluating Chebyshev polynomials, see grdmath.

The -N n_model+r (robust) and -I (iterative) options evaluate the significance of the improvement in model misfit Chi-Squared by an F-test. The default confidence limit is set at 0.51; it can be changed with the -I option. The user may be surprised to find that in most cases the reduction in variance achieved by increasing the number of terms in a model is not significant at a very high degree of confidence. For example, with 120 degrees of freedom, Chi-Squared must decrease by 26% or more to be significant at the 95% confidence level. If you want to keep iterating as long as Chi-Squared is decreasing, set confidence_level to zero.

A low confidence limit (such as the default value of 0.51) is needed to make the robust method work. This method iteratively reweights the data to reduce the influence of outliers. The weight is based on the Median Absolute Deviation and a formula from Huber [1964], and is 95% efficient when the model residuals have an outlier-free normal distribution. This means that the influence of outliers is reduced only slightly at each iteration; consequently the reduction in Chi-Squared is not very significant. If the procedure needs a few iterations to successfully attenuate their effect, the significance level of the F-test must be kept low.

## ASCII Format Precision

The ASCII output formats of numerical data are controlled by parameters in your gmt.conf file. Longitude and latitude are formatted according to FORMAT_GEO_OUT, absolute time is under the control of FORMAT_DATE_OUT and FORMAT_CLOCK_OUT, whereas general floating point values are formatted according to FORMAT_FLOAT_OUT. Be aware that the format in effect can lead to loss of precision in ASCII output, which can lead to various problems downstream. If you find the output is not written with enough precision, consider switching to binary output (-bo if available) or specify more decimals using the FORMAT_FLOAT_OUT setting.

## Examples

Note: Below are some examples of valid syntax for this module. The examples that use remote files (file names starting with `@`) can be cut and pasted into your terminal for testing. Other commands requiring input files are just dummy examples of the types of uses that are common but cannot be run verbatim as written.

To remove a planar trend from data.xyz by ordinary least squares, use

    gmt trend2d data.xyz -Fxyr -N3 > detrended_data.xyz

To simply report the three coefficients, use

    gmt trend2d data.xyz -Fp -N3 > parameters.txt

To make the above planar trend robust with respect to outliers, use

    gmt trend2d data.xzy -Fxyr -N3+r > detrended_data.xyz

To find out how many terms (up to 10 in a robust interpolant are significant in fitting data.xyz, use

    gmt trend2d data.xyz -N10+r -I -V

## See Also

gmt, grdmath, grdtrend, trend1d

## References

Huber, P. J., 1964, Robust estimation of a location parameter, Ann. Math. Stat., 35, 73-101.

Menke, W., 1989, Geophysical Data Analysis: Discrete Inverse Theory, Revised Edition, Academic Press, San Diego.